## TpBasePasswordChannel

TpBasePasswordChannel — a simple X-TELEPATHY-PASSWORD channel

## Properties

gchar * | authentication-method | Read
gchar * | authorization-identity | Read
GStrv | available-mechanisms | Read
gboolean | can-try-again | Read
gchar * | default-realm | Read
gchar * | default-username | Read
gboolean | has-initial-data | Read
gboolean | may-save-response | Read / Write / Construct Only
gchar * | sasl-error | Read
GHashTable_gchararray+GValue_* | sasl-error-details | Read
guint | sasl-status | Read

## Signals

void | finished | Run Last

## Types and Values

struct | TpBasePasswordChannel

## Object Hierarchy

        GObject
        ╰── TpBaseChannel
            ╰── TpBasePasswordChannel

## Implemented Interfaces

TpBasePasswordChannel implements TpSvcDBusProperties, TpSvcChannel, TpChannelIface, TpExportableChannel, TpSvcChannelTypeServerAuthentication and TpSvcChannelInterfaceSASLAuthentication.

## Includes

    #include <telepathy-glib/telepathy-glib.h>

## Description

This class implements a SASL Authentication channel with the X-TELEPATHY-PASSWORD SASL mechanism. Most of the time, you should not use or instantiate this class directly. It is used by TpSimplePasswordManager behind the scenes. In some special circumstances (e.g. when the authentication channel needs to implement additional interfaces), it may be necessary to create your own custom authentication channels instead of letting TpSimplePasswordManager create them automatically. In this case, you should derive your channel from this class and then pass the channel as an argument to `tp_simple_password_manager_prompt_for_channel_async()`.

## Functions

## Types and Values

### struct TpBasePasswordChannel

    struct TpBasePasswordChannel;

Data structure representing a channel implementing a SASL Authentication channel with the X-TELEPATHY-PASSWORD SASL mechanism.

Since: 0.13.15

## Property Details

### The `“authentication-method”` property

      “authentication-method”    gchar *

Interface of authentication method.

Owner: TpBasePasswordChannel

Flags: Read

Default value: ""

### The `“authorization-identity”` property

      “authorization-identity”   gchar *

Authorization identity.

Owner: TpBasePasswordChannel

Flags: Read

Default value: ""

### The `“available-mechanisms”` property

      “available-mechanisms”     GStrv

The set of mechanisms the server advertised.

Owner: TpBasePasswordChannel

Flags: Read

### The `“can-try-again”` property

      “can-try-again”            gboolean

Whether StartMechanism will work in failed states.

Owner: TpBasePasswordChannel

Flags: Read

Default value: FALSE

### The `“default-realm”` property

      “default-realm”            gchar *

DefaultRealm.

Owner: TpBasePasswordChannel

Flags: Read

Default value: ""

### The `“default-username”` property

      “default-username”         gchar *

DefaultUsername.

Owner: TpBasePasswordChannel

Flags: Read

Default value: ""

### The `“has-initial-data”` property

      “has-initial-data”         gboolean

Whether the StartMechanismWithData can be called.

Owner: TpBasePasswordChannel

Flags: Read

Default value: FALSE

### The `“may-save-response”` property

      “may-save-response”        gboolean

Whether the client may save the authentication response.

Owner: TpBasePasswordChannel

Flags: Read / Write / Construct Only

Default value: TRUE

### The `“sasl-error”` property

      “sasl-error”               gchar *

SASL error.

Owner: TpBasePasswordChannel

Flags: Read

Default value: ""

### The `“sasl-error-details”` property

      “sasl-error-details”       GHashTable_gchararray+GValue_*

SASL error details.

Owner: TpBasePasswordChannel

Flags: Read

### The `“sasl-status”` property

      “sasl-status”              guint

The status of the current SASL authentication.

Owner: TpBasePasswordChannel

Flags: Read

Allowed values: <= 7

Default value: 0

## Signal Details

### The `“finished”` signal

    void
    user_function (TpBasePasswordChannel *self,
                   GString               *password,
                   guint                  domain,
                   gint                   code,
                   gchar                 *message,
                   gpointer               user_data)

Emitted when either the password has been provided by the user or the authentication has been aborted.

#### Parameters

self | the TpBasePasswordChannel |
password | the password provided by the user, or `NULL` if the authentication has been aborted |
domain | domain of a GError indicating why the authentication has been aborted, or 0 |
code | error code of a GError indicating why the authentication has been aborted, or 0 |
message | a message associated with the error, or `NULL` |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 0.13.15